; String concatenation routines test

TimesToLoop equ 10
; procs to test
;Procs Textequ <OVH,t1,t2,t3,t4,t6,t7,t8,t9,t10,t11,t12,t13,t14,t15,t16,t17,t18,t19,t20>
Procs Textequ <OVH,t1,t2,t3,t4,t6,t8,t17,t18,t19,t20>
;Procs Textequ <OVH,OVH,OVH,OVH,OVH,OVH,OVH,OVH,OVH,OVH,OVH,OVH>
; string lengths to test
;Tests Textequ <1/1, 10/10, 100/100, 1000/1000, 1/1, 1/1, 1/1, 1/1, 1/1, 1/1, 1/1, 1/1, 1/1, 1/1, 1/1> 
Tests Textequ <1/1, 1000/1000, 1000/1000, 1000/1000, 1000/1000,1000/1000,1000/1000,1000/1000,1000/1000,1000/1000,1000/1000,1000/1000,1000/1000,1000/1000,1000/1000> 
PriClass textequ <REALTIME_PRIORITY_CLASS> ; priority to use for tests
;PriClass textequ <NORMAL_PRIORITY_CLASS>	; for debugging
    
;Procs TEXTEQU <szCatStr,hutchszCat2,kuntz2>
;Tests TEXTEQU <0/0, 1/0, 0/1, 1/1, 5/5, 13/17, 32/16, 223/271, 251/1031, 1031/251>

.686p
.model	flat, stdcall
option	casemap :none   ; case sensitive
.nolist
include windows.inc
uselib	MACRO	libname
	include		libname.inc
	includelib	libname.lib
ENDM
uselib user32
uselib kernel32
uselib comctl32
uselib gdi32
uselib shell32
uselib comdlg32
uselib masm32
uselib debug
include macros.asm

inv equ Invoke

soff Macro QuotedText:Vararg	; returns offset to a string
Local LocalText
.data
LocalText db QuotedText,0
.code
EXITM <offset LocalText>
Endm
.listall

.data?
align 16
StartingCycle dd ?
CyclePart2	  dd ?
Loops         dd ?
ExtraLoops    dd ?
Min           dd ?
OverHead      dd ?   ; overhead of doing an empty proc
.code
BeginCounter macro	; This macro is inserted before a block of test code
	align 16	; just to be sure all code starts with equal advantage
    invoke GetCurrentProcess
    invoke SetPriorityClass, eax, PriClass	; use the highest priority for all the tests
	invoke GetCurrentThread
	inv SetThreadPriority,eax,THREAD_PRIORITY_TIME_CRITICAL
            
	mov Min,9999999999
	mov Loops,TimesToLoop
	mov ExtraLoops,10	; will do several times first to let things settle out
    inv Sleep,0
ExtraLoopsLoop = $
	sub ExtraLoops,1
TimingLoop = $
	mov	[StartingCycle],eax		; just to make sure they are in the cache
	mov	[StartingCycle+4],eax
	Repeat 6	; Intel says 4 but I've found that more works a little better
	xor eax,eax
	cpuid 		; call the EAX=0 version of CPUID to clear pipeline (serialize) (finish any pending instructions)
	Endm
	rdtsc
	mov	[StartingCycle],eax
	mov	[StartingCycle+4],edx
endm
EndCounter macro		; This macro is inserted after each block of test code
	xor eax,eax
	cpuid		; flush
	rdtsc
	sub eax,[StartingCycle]	; get result in EDX:EAX
	sbb edx,[StartingCycle+4]
	cmp ExtraLoops,0
	jne ExtraLoopsLoop	; skip first several iterations
	cmp Min,eax
	jb @f
	mov Min,eax
@@:
	sub Loops,1
	jnz TimingLoop
	invoke GetCurrentThread
	inv SetThreadPriority,eax,THREAD_PRIORITY_NORMAL
    invoke GetCurrentProcess
    invoke SetPriorityClass, eax, NORMAL_PRIORITY_CLASS	; back to normal
    inv Sleep,0 
	mov eax,Min		; return the minimum elapsed time
	.if DoingOverhead==0
		sub eax,OverHead
	.endif
endm
;----------------------------  SETUP --------------------------------------

    MAXWIDTH  equ 20
    HDRWIDTH  equ 3 ;12
    COLWIDTH  equ 5 ;6

    %FOR proc,<Procs>
        proc proto :dword,:dword
    ENDM

	MaxStr=0
	scount=0
	%For T1T2,<Tests>	; get maximum string size
		local T1,T2,sep
	    sep instr 1,<T1T2>,</>
	    T1 substr <T1T2>,1,sep-1    ; len of string 1
	    if T1 GT MaxStr
	    	MaxStr=T1
	    endif
	    T2 substr <T1T2>,sep+1      ; len of string 2
	    if T2 GT MaxStr
	    	MaxStr=T2
	    endif
	    scount=scount+2
	ENDM

.data

align 16
String1 db MaxStr*2+64 dup (0)      ; what will be input string1 to routines.  The extra 64 bytes are to represent
align 16                            ;   a possible next string in the real world that we would not want wiped out.
String2 db MaxStr+32   dup (0)      ; what will be input string2 to routines    

align 16
Str1Offset      dd  0   ; offset to starting byte within String1 based upon number of extra bytes being tested
Str2Offset      dd  0   ; offset to starting byte within String2 based upon number of extra bytes being tested
Str1ZeroOffset  dd  0   ; computed offset to zero byte terminator of first string for each test
Str2ZeroOffset  dd  0   ; computed offset to zero byte terminator of second string
ErrorFound      dd  0   ; flag that an error was found processing a proc
Junk		    dd  0   ; scrath place for mem protect	
.code
align 16

;Printing routines from Phil
sxFld proc DDpointer:DWORD, rvstring:DWORD, DDwidth:DWORD, DDalign:DWORD    
    .if DDalign == 0                    ; align left?
        invoke szLeft,DDpointer,rvstring,DDwidth
        invoke szLen,rvstring
        mov edx,rvstring
    @@: cmp eax,DDwidth
        jae @F
        mov byte ptr [edx+eax],32	;space
        inc eax
        jmp @B
    @@: mov byte ptr [edx+eax],0
    .elseif DDalign == 1                ; align right?
        invoke szLen,DDpointer
        mov edx,rvstring
        xor ecx,ecx
    @@: cmp eax,DDwidth
        jae @F
        mov byte ptr [edx+ecx],32
        inc eax
        inc ecx
        jmp @B
    @@: add edx,ecx
        invoke szLeft,DDpointer,edx,DDwidth
    .endif
    ret 4*4
sxFld endp

fld$ MACRO DDpointer,DDwidth,DDalign:=<0>       ; Default is align left
    LOCAL rvstring
    .data
        rvstring db MAXWIDTH+4 dup (0)
        align 16
    .code
    invoke sxFld,reparg(DDpointer),ADDR rvstring,DDwidth,DDalign
    EXITM <ADDR rvstring>
ENDM

CheckForError proc T1:dword,T2:dword,ProcNamePtr:dword    ; check result string for correctness.  return 0=ok, 1=error
	local ErrorNum:dword
	mov ecx,ProcNamePtr
	mov eax,[ecx]
	cmp eax,0048564fh	; "OVH"  check for overhead proc
	jne @f
	ret
@@:
    mov esi,Str1Offset

	mov ErrorNum,1
    mov ecx,T1              ; there should first be T1 bytes of 255
    cmp ecx,0
    je Skip1                ; zero length string, skip this section
@@: lodsb
    cmp al,255
    jne PrintTheError
    loop @b

Skip1:
	Add ErrorNum,1
    mov ecx,T2              ; there should now be T2 bytes of 254
    cmp ecx,0
    je Skip2                ; zero length string, skip this section
@@: lodsb
    cmp al,254
    jne PrintTheError
    loop @b


Skip2:  
	Add ErrorNum,1
    lodsb                   ; there should now be the zero byte terminator
    cmp al,0
    jne PrintTheError

    mov ecx,32              ; there should be at least 32 non-zero bytes following which could represent 
	Add ErrorNum,1
@@: lodsb                   ;   a string following our output string in the real world
    and al,254              ; accept either 254 or 255
    cmp al,254
    jne PrintTheError
    loop @b

    clc ; all ok
    jmp CheckForErrorExit

PrintTheError:
    print chr$(13,10,"Error ")
    print sstr$(ErrorNum)
    print chr$(" in routine ")
    mov eax,ProcNamePtr
    print eax
    print chr$(13,10)

BadError:
    stc ; skip testing for rest of this proc

CheckForErrorExit:
    ret
CheckForError EndP

;----------------------------------------------------------------------------------------
;----------------------------------------------------------------------------------------
;----------------------------------------------------------------------------------------
.data
 wascalled dd 0
 DoingOverhead dd 0
.code

align 16

start:
	pcount=1
	%for proc,<Procs>	; count number of routines to test
		pcount=pcount+1
	endm
.data
	align 4
	ptable dd pcount dup (0)	; table of proc addresses
	lastproc dd 0				; address of last proc
	pname dd pcount dup (0)		; table of addresses of proc names for printing
.code
	mov edx,offset ptable	; address to call
	mov ecx,offset pname	; address of ascii name of routines for printing
	%for proc,<Procs>
		mov eax,offset proc
		mov [edx],eax		; save address of proc to call
		mov lastproc,edx	; save ending condition for loops
		add edx,4
.data
		ifndef &proc&name
			&proc&name db "&proc&",0	; save the proc names
		endif
.code
		mov [ecx],offset &proc&name
		add ecx,4
	endm
.data
	T1T2s dd scount dup (0)		; lengths of the test strings
	lastT1T2 dd 0  				; address of last T1T2 to use
.code
	mov edx,offset T1T2s
	%FOR T1T2,<Tests>	; get sizes
		local T1,T2,sep
	    sep instr 1,<T1T2>,</>
	    T1 substr <T1T2>,1,sep-1    ; len of string 1
	    T2 substr <T1T2>,sep+1      ; len of string 2
	    mov eax,T1
	    mov [edx],eax
	    mov eax,T2
	    mov [edx+4],eax
	    mov lastT1T2,edx
	    add edx,8
	ENDM
	maxextra=3
.data
	extras dd maxextra
.code
	mov eax,MaximumProcSize
	mov edx,offset TheProc
    inv VirtualProtect,edx,eax,PAGE_EXECUTE_READWRITE,addr Junk	; stupid invoke
    cpuid
    ;invoke GetCurrentProcess
    ;invoke FlushInstructionCache,eax,offset TheProc,MaximumProcSize
 
;   print out the headers
    print fld$(chr$("Str1 Size"),HDRWIDTH)

    mov ebx,offset T1T2s
    %FOR T1T2,<Tests>
        local sep
        sep instr 1,<T1T2>,</>
        print fld$(left$(chr$("&T1T2&"),sep-1),COLWIDTH,1)
    ENDM
    print chr$(13,10)
    print fld$(chr$("Str2 Size"),HDRWIDTH)
    %FOR T1T2,<Tests>
        local T1,T2,sep
        sep instr 1,<T1T2>,</>
        T1 substr <T1T2>,1,sep-1    ; len of string 1
        T2 substr <T1T2>,sep+1      ; len of string 2
        print fld$( remove$( chr$("&T1T2&"),left$(chr$("&T1T2&"),sep)),COLWIDTH,1)
    ENDM
    print chr$(13,10)

    print fld$(chr$("====================="),HDRWIDTH)
    %FOR T1T2,<Tests>
        print fld$(" =====================",COLWIDTH)
    ENDM
    print chr$(13,10)


.data?
	extracount dd ?	; step through extra bytes
	PAddr      dd ?	; address of proc to call
	PTblPtr    dd ?	; address of proc within table
	PNamePtr   dd ? ; address of proc name within table
	TPtr       dd ?	; address of number of bytes in string 1 to create
	T1Siz      dd ? ; size of string 1
	T2Siz      dd ? ; size of string 2
	TstCnt     dd ? ; number of times we have pre-tested
.code	
    ;FOR extra=0 to 3
    mov extracount,0	; initialize loop
	ExtraLoop:
        print chr$(13,10)
        mov ecx,extracount
        print sstr$(ecx)
        print chr$(" byte misalignment",13,10)
        ;%FOR proc,<Procs>
        mov PTblPtr,offset ptable	; initialize loop
        mov PNamePtr,offset pname
        procsloop:
            mov eax,PTblPtr	; get address of routine to test
            mov eax,[eax]
            mov PAddr,eax
            mov eax,PNamePtr
            mov eax,[eax]
            mov ecx,[eax]
            cmp ecx,0048564fh	; "OVH"  check for overhead proc
	        jne @f
	        mov DoingOverhead,1
	@@:
            print fld$(eax,HDRWIDTH)
           
           ; now move the proc to a standard location
           mov esi,PAddr
           mov ecx,MaximumProcSize
           mov edi,offset TheProc
           rep movsb
           mov PAddr,offset TheProc
           cpuid
            ;%FOR T1T2,<Tests>
          	mov TPtr,offset T1T2s	; initialize loop
          	T1T2loop: 
                mov ecx,TPtr				; get length of string 1
                mov eax,[ecx]
                mov T1Siz,eax
                mov eax,[ecx+4]				; get length of string 2
                mov T2Siz,eax
                ; create fresh test strings for each routine to use 
                mov eax,offset String1
                add eax,extracount			; start of string1 for testing
                mov Str1Offset,eax
                add eax,T1Siz
                mov Str1ZeroOffset,eax      ; where zero byte terminator will be
                
                mov eax,offset String2
                add eax,extracount          ; start of string2 for testing
                mov Str2Offset,eax
                add eax,T2Siz
                mov Str2ZeroOffset,eax     ; where zero byte terminator will be
                
                mov edi,offset String1      ; create test string values
                mov ecx,MaxStr*2+48         ; leave 16 bytes at end for accidents
                mov al,255
                rep stosb
                mov eax,Str1ZeroOffset
                mov [eax],byte ptr 0        ; set length of string
                
                mov edi,offset String2      ; create test string values
                mov ecx,MaxStr+16
                mov al,254
                rep stosb
                mov eax,Str2ZeroOffset
                mov [eax],byte ptr 0        ; set length of string
                

;;                ; run several times to verify operation before running a million times
                mov TstCnt,3
PreTest:
                mov eax,Str1ZeroOffset
                mov [eax],byte ptr 0        ; reset length of string

                push Str2Offset
                push Str1Offset
                ;mov eax,PAddr
                ;call eax         ;invoke proc,Str1Offset,Str2Offset
                call TheProc
	            mov eax,PNamePtr
	            mov eax,[eax]
                invoke CheckForError,T1Siz,T2Siz,eax
                jc QuitTests
                sub TstCnt,1
                jnz PreTest
                ; now do actual time test
                BeginCounter
                mov eax,Str1ZeroOffset
                mov [eax],byte ptr 0    ; reset length of string
                push Str2Offset         ;invoke proc,Str1Offset,Str2Offset
                push Str1Offset
                ;mov eax,PAddr
                ;call eax
                call TheProc
                EndCounter
                cmp DoingOverhead,1
                jne @f
                mov OverHead,eax
                mov DoingOverhead,0
@@:
                mov ebx,eax
                print fld$(sstr$(ebx),COLWIDTH,1)
                
                ; and one more check to be sure everything is still ok
	            mov eax,PNamePtr
	            mov eax,[eax]
                invoke CheckForError,T1Siz,T2Siz,eax
                jc QuitTests
            ;ENDM
            add TPtr,8
            mov eax,TPtr
            cmp eax,lastT1T2
            jbe T1T2loop
            print chr$(13,10)
       ;ENDM
       add PNamePtr,4
       add PTblPtr,4
       mov eax,PTblPtr
       cmp eax,lastproc
       jbe procsloop        
    ;ENDM
    add extracount,1
    cmp extracount,3
    jbe ExtraLoop
QuitTests:
    mov   eax,input(13,10,"Press enter to exit...")
    exit

; --------------------- Routines under test ---------------------------------------------
OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE

align 16
ProcMaxSize=0
PStart = $
hutchszCat2 proc src:DWORD,szadd:DWORD

    push edi

    xor eax, eax
    mov edx, [esp+8]    ; src
    mov edi, [esp+12]   ; szadd
    sub edx, 1
    xor ecx, ecx

  align 4
  @@:
    add edx, 1
    cmp BYTE PTR [edx], 0
    jne @B

  align 4
  @@:
    mov al, [edi+ecx]
    mov [edx+ecx], al
    add ecx, 1
    test al, al
    jnz @B

    mov eax, [esp+8]    ; src   return start address of source

    pop edi

    ret 8
hutchszCat2 endp
ProcSize = $ - PStart
if ProcSize gt ProcMaxSize
   ProcMaxSize=ProcSize
endif
.data
pppsize db ProcSize
.code
OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef
;-------------------------------------------------------------------------------
OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE

%for tcount,<1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20>
align 16
PStart = $
%t&tcount& proc xstr1:dword, xstr2:dword
    mov dword ptr [esp-4], ebx      ; push ebx
    mov dword ptr [esp-8], edi      ; push edi
    mov edi, dword ptr [esp+4]      ; xstr1
    align 4
d1: mov edx, dword ptr [edi]
    mov ecx, edx
    add edi, 4
    sub edx, 1010101h   ;16843009
    and edx, 80808080h  ;2155905152
    jz d1
    not ecx
    and edx, ecx
    jz d1
    test dl, dl
    jnz d2
    test dh, dh
    jnz d3
    test edx, 0FF0000h  ; 16711680
    jnz d4
    jmp d5
d2: dec edi
d3: dec edi
d4: dec edi
d5: dec edi
    mov eax, dword ptr [esp+8]      ; xstr2
    align 4
d6: mov edx, dword ptr [eax]
    mov ecx, edx
    add eax, 4
    sub edx, 1010101h   ;16843009
    and edx, 80808080h  ;2155905152
    jnz d7
    mov dword ptr [edi], ecx
    add edi, 4
    jmp d6
d7: mov ebx, ecx
    not ecx
    and edx, ecx
    jnz d8
    mov dword ptr [edi], ebx
    add edi, 4
    jmp d6
d8: mov dword ptr [edi], ebx
    mov edi, dword ptr [esp-8]      ; pop edi
    mov ebx, dword ptr [esp-4]      ; pop ebx
    ret 8

%t&tcount& endp
ProcSize=$-PStart
if ProcSize gt ProcMaxSize
   ProcMaxSize=ProcSize
endif
endm

align 16
PStart = $
OVH proc xstr1:dword, xstr2:dword
   ret 8
OVH EndP 
ProcSize=$-PStart
if ProcSize gt ProcMaxSize
   ProcMaxSize=ProcSize
endif

OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef
.data
MaximumProcSize dd ProcMaxSize
.code

;--------------------------  proc will be moved to here for testing
align 16
db 0
align 16
db 0
align 16
TheProc:
db ProcMaxSize+16 dup (0)

;-------------------------------------------------------------------------------

end start
